#version 330

${uniforms! }


layout(origin_upper_left) in vec4 gl_FragCoord;

uniform sampler2D image;
uniform vec4 fill;
uniform vec4 stroke;
uniform float strokeWeight;

${varyingIn! }
${outputs! }

out vec4 o_color;
struct VertexData {
    vec3 position;
    vec3 normal;

};

${fragmentPreamble! }

flat in int v_instance;

in VertexData world;
in VertexData view;
in VertexData object;
in VertexData clip;


void main(void) {
    vec4 x_fill = fill;
    vec4 x_stroke = stroke;
    {
        ${fragmentTransform! }
    }
    o_color = x_fill;
    o_color.rgb *= o_color.a;
}